import { world, system } from "@minecraft/server";


//stage 1
world.beforeEvents.worldInitialize.subscribe((initEvent) => {
  initEvent.blockComponentRegistry.registerCustomComponent("zc_cowcrops:trigger", {
    onPlayerInteract: (e) => {
      const block = e.block;
      if (!block) return;

      const blockLocation = block.location;
      const x = blockLocation.x;
      const y = blockLocation.y;
      const z = blockLocation.z;

      e.player
        .runCommandAsync(
          `execute @s[hasitem={item=bone_meal,location=slot.weapon.mainhand}] ~~~ summon zc:cow_s2 ${x} ${y} ${z}`
        )
        .catch((error) => console.warn("Error spawning loot:", error));

      
      e.player
        .runCommandAsync(
          `execute @s[hasitem={item=bone_meal,location=slot.weapon.mainhand}] ~~~ execute @e[type=zc:cow_s1,x=${x},y=${y},z=${z},r=1] ~~~ tp @s -96 -70 -32`
        )
        .catch((error) => console.warn("Error clearing gold ingot:", error));
        
        e.player
        .runCommandAsync(
          `execute @s[hasitem={item=bone_meal,location=slot.weapon.mainhand}] ~~~ setblock ${x} ${y} ${z} zc:cowcrops2`
        )
        .catch((error) => console.warn("Error spawning loot:", error));
        
        e.player
        .runCommandAsync(
          `execute @s[hasitem={item=bone_meal,location=slot.weapon.mainhand}] ~~~ clear @s bone_meal 0 1`
        )
        .catch((error) => console.warn("Error spawning loot:", error));
    },
  });
});



//stage 2


world.beforeEvents.worldInitialize.subscribe((initEvent) => {
	
  initEvent.blockComponentRegistry.registerCustomComponent("zc_cowcrops2:trigger", {
  	
    onPlayerInteract: (e) => {
      const block = e.block;
      if (!block) return;

      const blockLocation = block.location;
      const x = blockLocation.x;
      const y = blockLocation.y;
      const z = blockLocation.z;


      e.player
        .runCommandAsync(
          `execute @s[hasitem={item=bone_meal,location=slot.weapon.mainhand}] ~~~ summon zc:cow_s3 ${x} ${y} ${z}`
        )
        .catch((error) => console.warn("Error spawning loot:", error));

      e.player
        .runCommandAsync(
          `execute @s[hasitem={item=bone_meal,location=slot.weapon.mainhand}] ~~~ execute @e[type=zc:cow_s2,x=${x},y=${y},z=${z}] ~~~ tp @s -96 -70 -32`
        )
        .catch((error) => console.warn("Error clearing gold ingot:", error));
        
        e.player
        .runCommandAsync(
          `execute @s[hasitem={item=bone_meal,location=slot.weapon.mainhand}] ~~~ setblock ${x} ${y} ${z} zc:cowcrops3`
        )
        .catch((error) => console.warn("Error spawning loot:", error));
        
        e.player
        .runCommandAsync(
          `execute @s[hasitem={item=bone_meal,location=slot.weapon.mainhand}] ~~~ clear @s bone_meal 0 1`
        )
        .catch((error) => console.warn("Error spawning loot:", error));
    },
  });
});



//stage 3
world.beforeEvents.worldInitialize.subscribe((initEvent) => {

  initEvent.blockComponentRegistry.registerCustomComponent("zc_cowcrops3:trigger", {
    
    onPlayerInteract: (e) => {
      const block = e.block;
      if (!block) return;

      const blockLocation = block.location;
      const x = blockLocation.x;
      const y = blockLocation.y;
      const z = blockLocation.z;

      e.player
        .runCommandAsync(
          `summon cow ${x} ${y} ${z}`
        )
        .catch((error) => console.warn("Error spawning loot:", error));

      e.player
        .runCommandAsync(
          `execute @e[type=zc:cow_s3,x=${x},y=${y},z=${z},r=1] ~~~ tp @s -96 -70 -32`
        )
        .catch((error) => console.warn("Error clearing gold ingot:", error));
        
        
        e.player
        .runCommandAsync(
          `loot spawn ${x} ${y + 1} ${z} loot "entities/cow"`
        )
        .catch((error) => console.warn("Error spawning loot:", error));
        
        e.player
        .runCommandAsync(
          `loot spawn ${x} ${y + 1} ${z} loot "entities/cow"`
        )
        .catch((error) => console.warn("Error spawning loot:", error));
        
        e.player
        .runCommandAsync(
          `setblock ${x} ${y} ${z} air destroy`
        )
        .catch((error) => console.warn("Error spawning loot:", error));
    },
  });
});








world.afterEvents.playerPlaceBlock.subscribe(async (event) => {
    const player = event.player; 
    const block = event.block;
    const blockPos = block.location;

    if (block.typeId === "zc:cowcrops") {
        try {
            // Summon the custom entity just above the placed block
            await player.runCommandAsync(`summon zc:cow_s1 ${blockPos.x} ${blockPos.y} ${blockPos.z}`);
        } catch (error) {
            console.error(`Failed to summon entity: ${error}`);
        }
    }
});



